SystemOrganization addCategory: #'AST-Interpreter'!
SystemOrganization addCategory: #'AST-Interpreter-Test'!

!RBVariableBinding methodsFor: '*AST-Interpreter' stamp: 'CamilloBruni 12/5/2011 15:05'!
isArgument
	^ self isArgumentBinding! !

!RBVariableBinding methodsFor: '*AST-Interpreter' stamp: 'CamilloBruni 12/5/2011 15:05'!
isContext
	^ self isContextBinding! !

!RBVariableBinding methodsFor: '*AST-Interpreter' stamp: 'CamilloBruni 12/5/2011 15:05'!
isInstance
	^ self isInstanceBinding! !

!RBVariableBinding methodsFor: '*AST-Interpreter' stamp: 'CamilloBruni 12/5/2011 15:06'!
isLiteral
	^ self isLiteralBinding! !

!RBVariableBinding methodsFor: '*AST-Interpreter' stamp: 'CamilloBruni 12/5/2011 15:06'!
isSelf
	^ self isSelf! !

!RBVariableBinding methodsFor: '*AST-Interpreter' stamp: 'CamilloBruni 12/5/2011 15:06'!
isSuper
	^ self isSuperBinding! !

!RBVariableBinding methodsFor: '*AST-Interpreter' stamp: 'CamilloBruni 12/5/2011 15:06'!
isTemp
	^ self isTemporaryBinding! !

!RBVariableBinding methodsFor: '*AST-Interpreter' stamp: 'CamilloBruni 12/5/2011 15:06'!
isUndeclared
	^ self isUndeclaredBinding! !

!RBLiteralBinding methodsFor: '*AST-Interpreter' stamp: 'CamilloBruni 12/5/2011 16:02'!
readWith: anInterpreter
	self flag: 'maybe introduce indirections over the interpreter'.
	^ self value! !

!CompiledMethod methodsFor: '*AST-Interpreter' stamp: 'CamilloBruni 12/5/2011 16:12'!
accept: visitor on: receiver message: aMessage
	self isPrimitive ifTrue: [ 
			^ visitor 
				invokePrimitiveMethod: self 
				on: receiver 
				message: aMessage ].
			
	self isReflective ifTrue: [ 
		^ visitor 
			invokeReflectiveMethod: self
			on: receiver 
			message: aMessage].
		
	^ visitor 
		invokeMethod: self 
		on: receiver 
		message: aMessage! !

!CompiledMethod methodsFor: '*AST-Interpreter' stamp: 'CamilloBruni 12/5/2011 09:52'!
ast
	^ self parseTree annotateInClass: self methodClass! !

!CompiledMethod methodsFor: '*AST-Interpreter' stamp: 'CamilloBruni 12/5/2011 14:14'!
code
	^ self ast! !

!CompiledMethod methodsFor: '*AST-Interpreter' stamp: 'CamilloBruni 12/5/2011 11:08'!
isPrimitive
	^ self primitive ~= 0! !

!CompiledMethod methodsFor: '*AST-Interpreter' stamp: 'CamilloBruni 12/5/2011 16:14'!
isReflective
	^ (self pragmaAt: #reflective:) isNil not! !

!RBArgumentBinding methodsFor: '*AST-Interpreter' stamp: 'CamilloBruni 12/5/2011 16:04'!
readWith: anInterpreter
	^ anInterpreter readArgumentNamed: node name! !

MessageNotUnderstood subclass: #RecursiveMessageNotUnderstood
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AST-Interpreter'!

!RBVariableNode methodsFor: '*AST-Interpreter' stamp: 'CamilloBruni 12/5/2011 15:04'!
binding
	^ self variableBinding! !

!RBInstanceBinding methodsFor: '*AST-Interpreter' stamp: 'CamilloBruni 12/5/2011 15:18'!
accept: aVisitor assign: aValue
	^ aVisitor write: aValue at: index named: name! !

!RBInstanceBinding methodsFor: '*AST-Interpreter' stamp: 'CamilloBruni 12/5/2011 15:22'!
readWith: aVisitor
	^ aVisitor readInstVarAt: index named: name! !

Object subclass: #ASTClosure
	instanceVariableNames: 'code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AST-Interpreter'!

ASTClosure subclass: #ASTBlockClosure
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AST-Interpreter'!

!ASTBlockClosure methodsFor: 'visiting' stamp: 'CamilloBruni 10/5/2011 17:47'!
accept: visitor
	^ visitor visitBlockClosure: self! !

!ASTBlockClosure methodsFor: 'accessing' stamp: 'CamilloBruni 10/5/2011 17:48'!
context

	^ context! !

!ASTBlockClosure methodsFor: 'accessing' stamp: 'CamilloBruni 10/5/2011 17:48'!
context: anObject
	
	context := anObject! !

!ASTBlockClosure methodsFor: 'evaluating' stamp: 'CamilloBruni 12/5/2011 16:16'!
value
	<reflective: #blockClosureValue:message:>
	^ self valueWithArguments: (Array new: 0)! !

!ASTBlockClosure methodsFor: 'evaluating' stamp: 'CamilloBruni 12/5/2011 16:13'!
value: anArg
	<reflective: #blockClosureValue:message:>
	^ self valueWithArguments: (Array with: anArg)! !

!ASTBlockClosure methodsFor: 'evaluating' stamp: 'CamilloBruni 12/5/2011 16:13'!
value: anArg value: otherArg
	<reflective: #blockClosureValue:message:>
	^ self valueWithArguments: (Array with: anArg with: otherArg)! !

!ASTBlockClosure methodsFor: 'evaluating' stamp: 'CamilloBruni 12/5/2011 16:13'!
value: anArg value: otherArg value: anotherArg
	<reflective: #blockClosureValue:message:>
	^ self valueWithArguments: (Array with: anArg with: otherArg with: anotherArg)! !

!ASTBlockClosure methodsFor: 'evaluating' stamp: 'CamilloBruni 12/5/2011 16:13'!
value: anArg value: otherArg value: anotherArg value: yetAnotherArg
	<reflective: #blockClosureValue:message:>
	^ self valueWithArguments: (Array with: anArg with: otherArg with: anotherArg with: yetAnotherArg)! !

!ASTBlockClosure methodsFor: 'evaluating' stamp: 'CamilloBruni 12/5/2011 16:14'!
valueWithArguments: arguments
	<reflective: #blockClosureValueWithArguments:message:>
	PrimitiveFailed signal! !

!ASTBlockClosure methodsFor: 'controlling' stamp: 'CamilloBruni 10/5/2011 17:50'!
whileFalse
	self value ifFalse: [ self whileFalse ]! !

!ASTBlockClosure methodsFor: 'controlling' stamp: 'CamilloBruni 10/5/2011 17:51'!
whileFalse: aBlock
	^ self value 
		ifFalse: [ 
			aBlock value. 
			self whileFalse: aBlock ]! !

!ASTBlockClosure methodsFor: 'controlling' stamp: 'CamilloBruni 10/5/2011 17:50'!
whileTrue
	self value ifTrue: [ self whileTrue ]! !

!ASTBlockClosure methodsFor: 'controlling' stamp: 'CamilloBruni 10/5/2011 17:50'!
whileTrue: aBlock
	^ self value
		ifTrue: [ 
			aBlock value. 
			self whileTrue: aBlock ]! !

!ASTClosure methodsFor: 'accessing' stamp: 'CamilloBruni 10/5/2011 17:47'!
code

	^ code! !

!ASTClosure methodsFor: 'accessing' stamp: 'CamilloBruni 10/5/2011 17:47'!
code: anObject
	
	code := anObject! !

!ASTClosure methodsFor: 'evaluating' stamp: 'CamilloBruni 10/5/2011 17:47'!
valueWithPossibleArgs: anArray
	| numArgs |
	numArgs := self numArgs.
	numArgs = 0
		ifTrue: [ ^ self value ].
	numArgs = anArray size
		ifTrue: [ ^ self valueWithArguments: anArray ].
	numArgs > anArray size
		ifTrue: [ ^ self valueWithArguments: anArray , (Array new: numArgs - anArray size) ].
	^ self valueWithArguments: (anArray copyFrom: 1 to: numArgs)! !

ASTClosure subclass: #ASTMethodClosure
	instanceVariableNames: 'host selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AST-Interpreter'!

!ASTMethodClosure methodsFor: 'visiting' stamp: 'CamilloBruni 10/5/2011 17:47'!
accept: visitor
	^ visitor visitMethodClosure: self! !

!ASTMethodClosure methodsFor: 'accessing' stamp: 'CamilloBruni 10/5/2011 17:48'!
host

	^ host! !

!ASTMethodClosure methodsFor: 'accessing' stamp: 'CamilloBruni 10/5/2011 17:48'!
host: anObject
	
	host := anObject! !

!ASTMethodClosure methodsFor: 'accessing' stamp: 'CamilloBruni 10/5/2011 17:48'!
selector

	^ selector! !

!ASTMethodClosure methodsFor: 'accessing' stamp: 'CamilloBruni 10/5/2011 17:48'!
selector: anObject
	
	selector := anObject! !

Object subclass: #ASTInterpreter
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AST-Interpreter'!

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 12/5/2011 15:17'!
acceptAssignmentNode: anAssignmentNode
	| value variable |
	value := anAssignmentNode value acceptVisitor: self.
	variable := anAssignmentNode variable.
	variable binding accept: self assign: value. 
	^ value! !

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 10/5/2011 17:52'!
acceptBlockNode: aBlockNode
	^ ASTBlockClosure new
		context: self context;
		code: aBlockNode! !

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 10/5/2011 17:38'!
acceptLiteralArrayNode: aNode
	^ aNode value! !

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 10/5/2011 17:13'!
acceptLiteralNode: aLiteralNode
	^ aLiteralNode value! !

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 12/5/2011 15:59'!
acceptMessageNode: aMessageNode
	|receiver arguments message|
	
	receiver := aMessageNode receiver acceptVisitor: self.
	arguments := (aMessageNode arguments 
						collect: [ :argument|
							(argument acceptVisitor: self)]) asArray.
	message := Message selector: aMessageNode selector arguments: arguments.
	
	Transcript show: receiver class name; show: ' >> '; show: aMessageNode selector; cr.
	^ self
		send: message
		to: receiver
		class: (self classOf: receiver)
		for: aMessageNode! !

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 12/5/2011 10:10'!
acceptReturnNode: aReturnNode
	| returnValue |
	self flag: 'only local returns supported so far'.
	self flag: 'todo jump to the return handler, eg. home context...'.
	returnValue := aReturnNode value acceptVisitor: self.
	^ returnValue! !

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 10/6/2011 15:51'!
acceptSelfNode: aSelf
	^ self currentSelf! !

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 10/6/2011 15:48'!
acceptSequenceNode: aSequenceNode
	| lastResult |
	aSequenceNode statements do: [ :statement|
		lastResult := statement acceptVisitor: self ].
	^ lastResult! !

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 12/5/2011 15:14'!
acceptThisContextNode: thisContextNode
	^ self context! !

!ASTInterpreter methodsFor: 'visiting' stamp: 'CamilloBruni 12/5/2011 15:24'!
acceptVariableNode: aVariableNode
	^ aVariableNode binding readWith: self ! !

!ASTInterpreter methodsFor: 'context' stamp: 'CamilloBruni 12/5/2011 16:24'!
blockClosureValue: aBlockClosure message: aMessage
	| block result returnContext |
	
	block := aBlockClosure code.
	
	self assert: block arguments size = aMessage arguments size.
	block size = 0 ifTrue: [ ^ nil ].
	
	self flag: 'TODO: handle return context here, e.g. use slow exceptions'.
	returnContext := context.
	self blockContextFor: aBlockClosure message: aMessage.
	
	result := self interpretBlock: block.
	
	context := returnContext.
	^ result! !

!ASTInterpreter methodsFor: 'context' stamp: 'CamilloBruni 12/5/2011 16:20'!
blockClosureValueWithArguments: aBlockClosure message: aMessage
	^ self blockclosureValue: aBlockClosure message: (aMessage at: 1)! !

!ASTInterpreter methodsFor: 'context' stamp: 'CamilloBruni 12/5/2011 16:27'!
blockContextFor: aBlockClosure message: aMessage
	| block size |
	
	block := aBlockClosure code.
	size := block arguments size + block blockVariables size.
	
	size = 0 
		ifTrue: [ context := aBlockClosure context ]
		ifFalse: [ 
			context := (BlockContext new: size)
				returnContext: context;
				outerScope: aBlockClosure context;
				closure: aBlockClosure;
				homeContext: aBlockClosure context homeContext ].
			
	aMessage arguments withIndexDo: [ :value :index | 
		context at: index put: value ].! !

!ASTInterpreter methodsFor: 'context' stamp: 'CamilloBruni 12/5/2011 16:19'!
blockclosureValue: aBlockClosure message: aMessage
	| block result returnContext |
	block := aBlockClosure code.
	self assert: block params size = aMessage size.
	block size = 0 ifTrue: [ ^ nil ].
	
	returnContext := context.
	self blockContextFor: aBlockClosure message: aMessage.
	
	result := self interpretBlock: block.
	
	context := returnContext.
	^ result! !

!ASTInterpreter methodsFor: 'message-sending' stamp: 'CamilloBruni 10/5/2011 17:24'!
classOf: anObject
	^ anObject class! !

!ASTInterpreter methodsFor: 'accessing' stamp: 'CamilloBruni 10/6/2011 15:53'!
context
	^ context! !

!ASTInterpreter methodsFor: 'accessing' stamp: 'CamilloBruni 10/6/2011 15:53'!
currentSelf
	^ self context receiver! !

!ASTInterpreter methodsFor: 'interpretation' stamp: 'CamilloBruni 10/5/2011 17:13'!
interpret: anASTNode
	^ anASTNode acceptVisitor: self.! !

!ASTInterpreter methodsFor: 'interpretation' stamp: 'CamilloBruni 12/5/2011 16:28'!
interpretBlock: block
	^ block body acceptVisitor: self! !

!ASTInterpreter methodsFor: 'interpretation' stamp: 'CamilloBruni 10/6/2011 15:46'!
interpretMethod: method
	^ method body acceptVisitor: self! !

!ASTInterpreter methodsFor: 'method-evaluation' stamp: 'CamilloBruni 12/5/2011 14:14'!
invokeMethod: aClosure on: receiver message: aMessage
	| result method |
	
	method := aClosure code.
	self assert: aClosure numArgs = aMessage numArgs.
	aClosure size = 0 
		ifTrue: [ ^ receiver ].
	
	self
		methodContextFor: aClosure
		receiver: receiver
		message: aMessage.
		
	result := self interpretMethod: method.
	context := context outerContext.
	self flag: 'TODO: remove debugging tests here'.
	context ifNil: [ ^ result ].
	self assert: (context isKindOf: ContextPart).
	^ result! !

!ASTInterpreter methodsFor: 'method-evaluation' stamp: 'CamilloBruni 12/5/2011 11:20'!
invokePrimitiveMethod: aCompiledMethod on: receiver message: aMessage
	| result |
	self flag: 'TODO: should track the tower of interpreters properly...'.
	self flag: 'TODO: manually invoke the primitive'.
	^ aMessage sendTo: receiver! !

!ASTInterpreter methodsFor: 'method-evaluation' stamp: 'CamilloBruni 12/5/2011 16:19'!
invokeReflectiveMethod: aClosure on: receiver message: aMessage
	| annotation selector |
	
	annotation := aClosure pragmaAt: #reflective:.
	selector := annotation arguments first.
	
	(self respondsTo: selector) ifTrue: [
		^ self 
			perform: selector 
			withArguments: (Array with: receiver with: aMessage)].
		
	^ self invokeMethod: aClosure on: receiver message: aMessage! !

!ASTInterpreter methodsFor: 'message-sending' stamp: 'CamilloBruni 10/5/2011 17:27'!
lookupSelector: selector in: class
	| currentClass |
	currentClass := class.
	[ currentClass isNil ] whileFalse: [ 
			currentClass methodDict at: selector ifPresent: [ :method | ^ method ].
			currentClass := currentClass superclass ].
	^ nil! !

!ASTInterpreter methodsFor: 'context' stamp: 'CamilloBruni 10/6/2011 15:44'!
methodContextFor: aCompiledMethod receiver: receiver message: aMessage
	context := MethodContext 
						sender: context 
						receiver: receiver 
						method: aCompiledMethod
						arguments: aMessage arguments.! !

!ASTInterpreter methodsFor: 'slot' stamp: 'CamilloBruni 12/5/2011 15:29'!
readArgumentNamed: aName
	^ self context tempNamed: aName! !

!ASTInterpreter methodsFor: 'slot' stamp: 'CamilloBruni 12/5/2011 15:22'!
readInstVarAt: index named: name
	^ self currentSelf instVarAt: index! !

!ASTInterpreter methodsFor: 'message-sending' stamp: 'CamilloBruni 10/5/2011 17:27'!
recursiveDoesNotUnderstand: aMessage on: receiver
	^ RecursiveMessageNotUnderstood new
		receiver: receiver;
		cls: receiver class;
		message: aMessage;
		signal! !

!ASTInterpreter methodsFor: 'message-sending' stamp: 'CamilloBruni 10/5/2011 17:24'!
send: aMessage to: receiver
	^ self
		send: aMessage
		to: receiver
		class: (self classOf: receiver)! !

!ASTInterpreter methodsFor: 'message-sending' stamp: 'CamilloBruni 10/5/2011 17:24'!
send: aMessage to: receiver class: class
	| method |
	method := self lookupSelector: aMessage selector in: class.
	method ifNil: [ ^ self sendDoesNotUnderstandFor: aMessage to: receiver ].
	^ method
		accept: self
		on: receiver
		message: aMessage! !

!ASTInterpreter methodsFor: 'message-sending' stamp: 'CamilloBruni 12/5/2011 14:51'!
send: aMessage to: receiver class: class for: aSend
	
	|method|
	
	method := self lookupSelector: aMessage selector in: class.
	method ifNil: [ ^ self sendDoesNotUnderstandFor: aMessage to: receiver ].
	
	self flag: 'create method closures...'.
	self flag: 'Maybe extend the MOP here...'.
	
	^ method
		accept: self 
		on: receiver
		message: aMessage! !

!ASTInterpreter methodsFor: 'message-sending' stamp: 'CamilloBruni 10/5/2011 17:25'!
sendDoesNotUnderstandFor: aMessage to: receiver
	| dnu |
	aMessage selector = #doesNotUnderstand:
		ifTrue: [ ^ self recursiveDoesNotUnderstand: (aMessage at: 1) on: receiver ].
	dnu := Message selector: #doesNotUnderstand: argument: aMessage.
	^ self send: dnu to: receiver! !

!ASTInterpreter methodsFor: 'slot' stamp: 'CamilloBruni 12/5/2011 15:23'!
write: aValue at: index named: name
	^ self currentSelf instVarAt: index put: aValue! !
